using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_Mythos._0_Modelos;
using Exferia_Aplicacion.Modelos_MantenimientoSimple;
using static Exferia_Aplicacion.General.Enumerados;
using Exferia_General._1_Datos;
using System.Transactions;
using System.Data.SqlClient;
using Exferia_Mythos.General;

namespace Exferia_Mythos._1_Datos
{
    public class MYT_PartesEstados_Datos : ABS_Datos
    {

        #region Listado
        private List<INTERNO_MYT_PartesEstados_Listado_Modelo> g_lst_INTERNO_MYT_PartesEstados_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_MYT = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta...........................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MYT_PartesEstados).Name), _lst_CamposConRelacionABuscar, -1, null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                //...................................................

                if ((g_lst_INTERNO_MYT_PartesEstados_Listado_Modelo != null) && (g_lst_INTERNO_MYT_PartesEstados_Listado_Modelo.Count() > 0))
                {
                    lst_MYT = g_lst_INTERNO_MYT_PartesEstados_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PartesEstados_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_MYT;
        }

        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MYT = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta..................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MYT_PartesEstados).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                //..........................................................

                if ((g_lst_INTERNO_MYT_PartesEstados_Listado_Modelo != null) && (g_lst_INTERNO_MYT_PartesEstados_Listado_Modelo.Count() > 0))
                {
                    dnm_MYT = g_lst_INTERNO_MYT_PartesEstados_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PartesEstados_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MYT;
        }

        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                string str_SQL =
                   " SELECT " +
                       nameof(INTERNO_MYT_PartesEstados_Listado_Modelo.id) + " = " + nameof(MYT_PartesEstados.id) + "," +
                       nameof(INTERNO_MYT_PartesEstados_Listado_Modelo.codigo) + " = " + nameof(MYT_PartesEstados.codigo) + "," +
                       nameof(INTERNO_MYT_PartesEstados_Listado_Modelo.descripcion) + " = " + nameof(MYT_PartesEstados.descripcion) + "," +
                       nameof(INTERNO_MYT_PartesEstados_Listado_Modelo.colorFondo) + " = " + nameof(MYT_PartesEstados.colorFondo) + "," +
                       nameof(INTERNO_MYT_PartesEstados_Listado_Modelo.colorLetra) + " = " + nameof(MYT_PartesEstados.colorLetra) +
               " FROM " + nameof(MYT_PartesEstados) +
               " WHERE " + nameof(MYT_PartesEstados.fechaBorrado) + " IS null AND " +
                       (_lng_id > -1 ? (nameof(MYT_PartesEstados.id) + "=@id") : "1 = 1");

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_lst_INTERNO_MYT_PartesEstados_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_MYT_PartesEstados_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PartesEstados_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        private INTERNO_MYT_PartesEstados_Listado_Modelo g_mdl_INTERNO_MYT_PartesEstados_Listado_Modelo_F3 = null;


        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MYT = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta...........................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MYT_PartesEstados).Name), _str_CampoBusqueda, _str_filtro, -1, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                //...................................................................

                if (g_mdl_INTERNO_MYT_PartesEstados_Listado_Modelo_F3 != null)
                {
                    dnm_MYT = g_mdl_INTERNO_MYT_PartesEstados_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PartesEstados_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MYT;
        }

        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MYT = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MYT_PartesEstados).Name), "", "", _lng_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                //....................

                if (g_mdl_INTERNO_MYT_PartesEstados_Listado_Modelo_F3 != null)
                {
                    dnm_MYT = g_mdl_INTERNO_MYT_PartesEstados_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PartesEstados_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MYT;
        }


        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                string str_SQL =
                   " SELECT distinct " +
                        nameof(INTERNO_MYT_PartesEstados_Listado_Modelo.id) + " = " + nameof(MYT_PartesEstados.id) + "," +
                        nameof(INTERNO_MYT_PartesEstados_Listado_Modelo.codigo) + " = " + nameof(MYT_PartesEstados.codigo) + "," +
                        nameof(INTERNO_MYT_PartesEstados_Listado_Modelo.descripcion) + " = " + nameof(MYT_PartesEstados.descripcion) + "," +
                        nameof(INTERNO_MYT_PartesEstados_Listado_Modelo.colorFondo) + " = " + nameof(MYT_PartesEstados.colorFondo) + "," +
                        nameof(INTERNO_MYT_PartesEstados_Listado_Modelo.colorLetra) + " = " + nameof(MYT_PartesEstados.colorLetra) + "," +
                        nameof(INTERNO_MYT_PartesEstados_Listado_Modelo.estadoInterno) + " = " + nameof(MYT_PartesEstados.estadoInterno) +
               " FROM " + nameof(MYT_PartesEstados) +
               " WHERE " + nameof(MYT_PartesEstados.fechaBorrado) + " IS null AND " +
                       (
                        (_lng_id > -1)
                          ? (nameof(MYT_PartesEstados.id) + " = " + _lng_id)
                          : (
                               //Filtrar por Codigo
                               (_str_CampoBusqueda.Equals(nameof(MYT_PartesEstados.codigo)))
                                   ? (nameof(MYT_PartesEstados.codigo) + "=@Filtro")
                                   //Filtrar por Descripcion
                                   : (nameof(MYT_PartesEstados.descripcion) + "=@Filtro")
                           )
                       );

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@Filtro",  _str_Filtro)
                };

                //Rellenar el Modelo
                g_mdl_INTERNO_MYT_PartesEstados_Listado_Modelo_F3 = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_MYT_PartesEstados_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PartesEstados_Datos) + "/" + nameof(ConsultaRellenar_F3), true);
            }
        }
        #endregion

        #region Obtener
        private dynamic g_dnm_Modelo_Obtener = null;
        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                          " SELECT " +
                              nameof(MYT_PartesEstados) + "." + nameof(MYT_PartesEstados.id) + " , " +
                              nameof(MYT_PartesEstados) + "." + nameof(MYT_PartesEstados.codigo) + " , " +
                              nameof(MYT_PartesEstados) + "." + nameof(MYT_PartesEstados.descripcion) + " , " +
                              nameof(MYT_PartesEstados) + "." + nameof(MYT_PartesEstados.colorFondo) + " , " +
                              nameof(MYT_PartesEstados) + "." + nameof(MYT_PartesEstados.colorLetra) + " , " +
                              nameof(MYT_PartesEstados) + "." + nameof(MYT_PartesEstados.fechaBorrado) + " , " +
                              nameof(MYT_PartesEstados) + "." + nameof(MYT_PartesEstados.estadoInterno) +
                        " FROM " + nameof(MYT_PartesEstados) +
                        " WHERE  " + nameof(MYT_PartesEstados) + "." + nameof(MYT_PartesEstados.fechaBorrado) + " IS null AND " +
                                     nameof(MYT_PartesEstados) + "." + nameof(MYT_PartesEstados.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<MYT_PartesEstados>(str_SQL, arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PartesEstados_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }

        public List<long> Obtener_PartesEstados_Terminados()
        {
            Exferia_Entities obj_Exferia_Entities = null;

            List<long> lst_ids = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                          " SELECT " +
                              nameof(MYT_PartesEstados) + "." + nameof(MYT_PartesEstados.id) + 
                        " FROM " + nameof(MYT_PartesEstados) +
                        " WHERE  " + nameof(MYT_PartesEstados) + "." + nameof(MYT_PartesEstados.estadoInterno) + " in ('" + Variables_Mythos.G_MDL_ESTADOSINTERNOSPARTES_TERMINADOCONINCIDENCIAS.Codigo + "','" + Variables_Mythos.G_MDL_ESTADOSINTERNOSPARTES_TERMINADO.Codigo + "') ";



                //Rellenar el Modelo
                lst_ids = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL, new object[] { }).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PartesEstados_Datos) + "/" + nameof(Obtener_PartesEstados_Terminados), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_ids;
        }

        public long? Obtener_PartesEstados_Pendiente()
        {
            Exferia_Entities obj_Exferia_Entities = null;

            long? lng_id = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                          " SELECT " +
                              nameof(MYT_PartesEstados) + "." + nameof(MYT_PartesEstados.id) +
                        " FROM " + nameof(MYT_PartesEstados) +
                        " WHERE  " +
                            nameof(MYT_PartesEstados) + "." + nameof(MYT_PartesEstados.fechaBorrado) + " is null and " +
                            nameof(MYT_PartesEstados) + "." + nameof(MYT_PartesEstados.estadoInterno) + " = '" + Variables_Mythos.G_MDL_ESTADOSINTERNOSPARTES_PENDIENTE.Codigo + "' ";

                //Rellenar el Modelo
                lng_id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL, new object[] { }).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PartesEstados_Datos) + "/" + nameof(Obtener_PartesEstados_Pendiente), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lng_id;
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private MYT_PartesEstados g_mdl_MYT_PartesEstados = null;

        public MYT_PartesEstados Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                      //WHERE
                                      " WHERE " + nameof(MYT_PartesEstados) + "." + nameof(MYT_PartesEstados.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PartesEstados_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_MYT_PartesEstados;
        }
        #region Ejecutar Consulta
        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_MYT_PartesEstados = obj_Exferia_Entities.Database.SqlQuery<MYT_PartesEstados>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PartesEstados_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #endregion
        #endregion

        #region Modelo Listado
        private List<MYT_PartesEstados> g_lst_MYT_PartesEstados = null;

        public List<MYT_PartesEstados> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids)
        {
            try
            {
                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {
                    string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(MYT_PartesEstados),
                                                                                             nameof(MYT_PartesEstados.id),
                                                                                             G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                             _lst_Ids);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                                " WHERE " +
                                                    str_Filtro_IDS;

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { });
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PartesEstados_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_MYT_PartesEstados;
        }

        public List<MYT_PartesEstados> Obtener_ModeloListado()
        {
            try
            {
                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE  " + nameof(MYT_PartesEstados) + "." + nameof(MYT_PartesEstados.fechaBorrado) + " IS null ";

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 new object[] { });
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PartesEstados_Datos) + "/" + nameof(Obtener_ModeloListado), true);
            }

            return g_lst_MYT_PartesEstados;
        }
        #region Ejecutar Consulta
        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                     object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_MYT_PartesEstados = obj_Exferia_Entities.Database.SqlQuery<MYT_PartesEstados>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PartesEstados_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #endregion
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(MYT_PartesEstados.id) + " , " +
                    nameof(MYT_PartesEstados.codigo) + " , " +
                    nameof(MYT_PartesEstados.descripcion) + " , " +
                    nameof(MYT_PartesEstados.colorFondo) + " , " +
                    nameof(MYT_PartesEstados.colorLetra) + " , " +
                    nameof(MYT_PartesEstados.fechaBorrado) + " , " +
                    nameof(MYT_PartesEstados.estadoInterno) +
                " FROM " + nameof(MYT_PartesEstados);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                MYT_PartesEstados mdl_MYT_PartesEstados_AGrabar = (MYT_PartesEstados)_mdl_obj;
                MYT_PartesEstados mdl_MYT_PartesEstados_DatosViejos = new MYT_PartesEstados();

                // Ver si existe ######################################################################
                MYT_PartesEstados mdl_MYT_PartesEstados_Final = Obtener_Modelo_Por_Id(mdl_MYT_PartesEstados_AGrabar.id);
                //######################################################################################

                //UPDATE
                if (mdl_MYT_PartesEstados_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_MYT_PartesEstados_Final, mdl_MYT_PartesEstados_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MYT_PartesEstados_AGrabar, mdl_MYT_PartesEstados_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(MYT_PartesEstados) +
                                           " SET " +
                                               nameof(MYT_PartesEstados.codigo) + "=@codigo," +
                                               nameof(MYT_PartesEstados.descripcion) + "=@descripcion," +
                                               nameof(MYT_PartesEstados.colorFondo) + "=@colorFondo," +
                                               nameof(MYT_PartesEstados.colorLetra) + "=@colorLetra," +
                                               nameof(MYT_PartesEstados.fechaBorrado) + "=@fechaBorrado, " +
                                               nameof(MYT_PartesEstados.estadoInterno) + "=@estadoInterno " +
                                           " WHERE " +
                                               nameof(MYT_PartesEstados.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                         new SqlParameter("@codigo",  mdl_MYT_PartesEstados_Final.codigo),
                         new SqlParameter("@descripcion",  mdl_MYT_PartesEstados_Final.descripcion),
                         new SqlParameter("@colorFondo",  mdl_MYT_PartesEstados_Final.colorFondo),
                         new SqlParameter("@colorLetra",  mdl_MYT_PartesEstados_Final.colorLetra),
                         mdl_MYT_PartesEstados_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_MYT_PartesEstados_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                         mdl_MYT_PartesEstados_Final.estadoInterno!=null
                            ?   new SqlParameter("@estadoInterno", mdl_MYT_PartesEstados_Final.estadoInterno)
                            :   new SqlParameter("@estadoInterno",  DBNull.Value),
                         new SqlParameter("@id",  mdl_MYT_PartesEstados_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_MYT_PartesEstados_Final.id;
                }
                //INSERT
                else
                {
                    mdl_MYT_PartesEstados_Final = new MYT_PartesEstados();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MYT_PartesEstados_AGrabar, mdl_MYT_PartesEstados_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(MYT_PartesEstados) +
                                              " (" +
                                                      nameof(MYT_PartesEstados.codigo) + "," +
                                                      nameof(MYT_PartesEstados.descripcion) + "," +
                                                      nameof(MYT_PartesEstados.colorFondo) + "," +
                                                      nameof(MYT_PartesEstados.colorLetra) + "," +                                                    
                                                      nameof(MYT_PartesEstados.fechaBorrado) + "," +
                                                      nameof(MYT_PartesEstados.estadoInterno) +
                                              " ) " +
                                              " OUTPUT INSERTED." + nameof(MYT_PartesEstados.id) +
                                              " VALUES " +
                                              " ( " +
                                                  "@codigo," +
                                                  "@descripcion," +
                                                  "@colorFondo," +
                                                  "@colorLetra," +
                                                  "@fechaBorrado," +
                                                  "@estadoInterno" +
                                              " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_MYT_PartesEstados_Final.codigo),
                        new SqlParameter("@descripcion",  mdl_MYT_PartesEstados_Final.descripcion),
                        new SqlParameter("@colorFondo",  mdl_MYT_PartesEstados_Final.colorFondo),
                        new SqlParameter("@colorLetra",  mdl_MYT_PartesEstados_Final.colorLetra),
                        mdl_MYT_PartesEstados_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_MYT_PartesEstados_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                         mdl_MYT_PartesEstados_Final.estadoInterno!=null
                            ?   new SqlParameter("@estadoInterno", mdl_MYT_PartesEstados_Final.estadoInterno)
                            :   new SqlParameter("@estadoInterno",  DBNull.Value),
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(MYT_PartesEstados), mdl_MYT_PartesEstados_DatosViejos, mdl_MYT_PartesEstados_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PartesEstados_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                MYT_PartesEstados mdl_MYT_PartesEstados_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_MYT_PartesEstados_Final != null)
                {
                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(MYT_PartesEstados) +
                                                " SET " +
                                                nameof(MYT_PartesEstados.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(MYT_PartesEstados.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@fechaBorrado",  DateTime.Now),
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(MYT_PartesEstados), null, mdl_MYT_PartesEstados_Final, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                //Devolver también el objeto
                mdl_INTERNO_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_PartesEstados_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }

        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            throw new NotImplementedException();
        }
        #endregion
    }
}
